#line 2 "lex.l"
/* This file is part of Mailfromd.
   Copyright (C) 2005, 2006, 2007, 2008, 2009 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#define MF_SOURCE_NAME  MF_SOURCE_LEX
	
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif



#line 27 "lex.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

/* %not-for-header */

/* %if-c-only */
/* %if-not-reentrant */

/* %endif */
/* %endif */
/* %ok-for-header */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* %if-c++-only */
/* %endif */

/* %if-c-only */
    
/* %endif */

/* %if-c-only */

/* %endif */

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
/* %if-c-only */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
/* %endif */

/* %if-tables-serialization */
/* %endif */
/* end standard C headers. */

/* %if-c-or-c++ */
/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! FLEXINT_H */

/* %endif */

/* %if-c++-only */
/* %endif */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* %not-for-header */

/* Returned upon end-of-file. */
#define YY_NULL 0
/* %ok-for-header */

/* %not-for-header */

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)
/* %ok-for-header */

/* %if-reentrant */
/* %endif */

/* %if-not-reentrant */

/* %endif */

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

/* %if-not-reentrant */
extern int yyleng;
/* %endif */

/* %if-c-only */
/* %if-not-reentrant */
extern FILE *yyin, *yyout;
/* %endif */
/* %endif */

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
/* %if-c-only */
	FILE *yy_input_file;
/* %endif */

/* %if-c++-only */
/* %endif */

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */

/* %if-not-reentrant */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */
/* %endif */
/* %ok-for-header */

/* %endif */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* %if-c-only Standard (non-C++) definition */

/* %if-not-reentrant */
/* %not-for-header */

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;
/* %ok-for-header */

/* %endif */

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

/* %endif */

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* %% [1.0] yytext/yyin/yyout/yy_state_type/yylineno etc. def's & init go here */
/* Begin user sect3 */

#define FLEX_DEBUG

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

/* %if-c-only Standard (non-C++) definition */

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* %endif */

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
/* %% [2.0] code to fiddle yytext and yyleng for yymore() goes here \ */\
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
/* %% [3.0] code to copy yytext_ptr to yytext[] goes here, if %array \ */\
	(yy_c_buf_p) = yy_cp;

/* %% [4.0] data tables for the DFA and the user's section 1 definitions go here */
#define YY_NUM_RULES 143
#define YY_END_OF_BUFFER 144
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[960] =
    {   0,
        0,    0,    2,    2,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  144,  142,  128,  129,  142,  142,
       14,  142,  142,  136,  142,  142,  142,   97,   97,  132,
      130,  134,   98,  142,  138,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,  137,  139,  128,   14,    2,    4,    3,
        2,    2,  143,  143,  110,  124,  124,  143,  141,  126,
      124,  124,  141,  143,  127,  143,  141,  120,  141,   98,
       98,   98,  128,   14,  128,  131,    0,  100,  102,  102,
       14,   13,   84,   88,   86,   89,    0,   80,   80,    0,

        0,   99,    0,    1,   96,    0,   97,    0,  133,  130,
      135,   98,   93,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   28,   98,   98,   98,   24,
       98,   98,   98,   98,   23,   98,   98,   98,   98,   98,
       98,   98,   98,   27,   35,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,  128,    0,   14,   14,
       14,   14,   14,   14,   14,    2,    3,    3,    5,    2,
        2,    2,    2,    0,  110,  111,  111,   85,  123,   87,
       90,    0,   81,   81,    0,  117,  109,  117,   94,  117,
        0,  126,  121,  125,    0,  127,  122,    0,  120,   75,

       98,   98,  128,    0,   14,  102,  108,  101,  108,  108,
       86,   89,    0,   80,   80,    0,    0,  140,   96,   95,
        0,    0,    0,    0,   93,   98,   98,   98,   98,   98,
       98,   98,   98,   20,   98,   36,   98,   98,   71,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   61,
       98,   57,   98,   98,   98,   98,   98,   98,    0,   98,
       37,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       40,   98,   98,   98,   98,   98,   98,   98,   98,    0,
        0,    0,    0,    0,    0,    0,   14,   14,   14,   14,
       14,   14,   14,    2,  109,   87,   90,    0,   81,   81,

        0,    0,  116,  115,   94,    0,   98,   98,    0,  101,
      107,  106,    0,    0,   91,   80,   80,   80,   80,   80,
       80,   80,    0,   82,    0,   95,    0,    0,    0,    0,
      118,    0,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   47,   98,   98,
       98,   98,   98,   98,   29,   42,   26,   25,   98,   67,
       45,   98,   55,   98,   98,    0,    0,    0,   38,   98,
       59,   98,   39,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   34,   98,    0,    0,    0,    0,
        0,    0,    0,   14,   14,   14,   14,   14,   14,    2,

        0,   92,   81,   81,   81,   81,   81,   81,   81,    0,
       83,    0,  114,  115,  113,   74,   73,  105,  106,  104,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   62,   60,   58,   41,   53,   98,   98,
       98,   98,   98,   98,   98,   98,    0,    0,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   54,
       63,   56,    0,    0,    0,    0,    0,    0,   14,   14,
       14,   14,   14,   14,   14,    2,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,    0,    0,    0,
        0,    0,    0,    0,  115,  112,  106,  103,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  119,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   15,   98,   98,   22,
       98,   98,   66,   98,   70,    0,    0,   52,   98,   69,
       16,   98,   98,   43,   68,   51,   46,   98,    0,    0,
        0,    0,    0,    0,    0,   14,    6,   14,   14,   14,
       14,   14,   14,    2,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   48,   19,   98,   30,    0,    0,    0,
       50,   98,   21,   65,   44,    0,   49,   98,    0,    6,
        0,    0,    0,    0,    0,    0,   14,   14,   14,    7,
       14,   14,    2,    7,    0,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   72,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   18,   98,    0,    0,   64,   17,    0,    0,
        0,    0,   14,    9,   14,   14,   14,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       76,   80,   80,   80,   80,   80,   80,   80,   80,   80,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,   98,   72,   98,   98,   98,   98,   98,   31,    0,
        0,    0,    9,    0,    0,    0,   14,   14,   14,    8,
       14,   77,   81,   81,   81,   81,   81,   81,   81,   81,
       81,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   80,   76,   80,   80,   80,   80,   80,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,   98,
       98,   98,   98,   98,    0,   32,    0,    0,    0,    8,
        0,   14,   11,   14,   14,   12,   81,   77,   81,   81,
       81,   81,   81,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,   80,   80,   80,   80,   80,   78,    0,

        0,    0,    0,    0,    0,    0,   98,   98,    0,    0,
       11,    0,    0,   12,   14,   81,   81,   81,   81,   81,
       79,    0,    0,    0,    0,    0,    0,    0,   80,   80,
        0,    0,    0,    0,    0,   33,    0,   14,   81,   81,
        0,    0,    0,    0,    0,    0,    0,    0,   14,    0,
        0,    0,   14,    0,   14,   10,    0,   10,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
        1,   13,    1,    1,   14,   15,   16,   17,   18,   18,
       18,   18,   18,   18,   18,   19,   19,    1,    1,   20,
       21,   22,    1,    1,   23,   23,   23,   23,   23,   23,
       24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
       24,   24,   24,   24,   24,   24,   24,   25,   24,   24,
        1,   26,    1,   27,   28,    1,   29,   30,   31,   32,

       33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
       43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
       53,   24,   54,   55,   56,   57,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[58] =
    {   0,
        1,    1,    2,    1,    1,    1,    3,    4,    5,    1,
        6,    7,    8,    9,    1,    1,   10,   11,   11,    1,
        1,    1,   12,   13,   13,   14,    1,   13,   12,   12,
       12,   12,   12,   12,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   15,    1,   16,    1
    } ;

static yyconst flex_int16_t yy_base[1021] =
    {   0,
        0,   56,   56,   63,   65,   69,   76,   78,   80,   89,
       77,   79,   64,   92, 2183, 2184,   60, 2184, 2161,  101,
     2178,  104,   84, 2184, 2169, 2164, 2165,  100,  112,   93,
     2156, 2155,    0,  101, 2184, 2147,  101,   91,   97,  102,
      111,  113,  113, 2131,  105,  127,  119,  117, 2140,  116,
      135, 2143, 2135, 2184, 2184,  170,  176,    0, 2184,  168,
      181,  171,  181, 2184, 2184,  184,  173,  207,  197, 2161,
      210,  187,  180,  227, 2184,  225, 2166, 2184, 2184,  208,
     2125,  208,  245,  276,  210, 2184,  257, 2184, 2184,  216,
     2164, 2184, 2184, 2184,  243,    0,    0,    0, 2138, 2137,

     2153, 2184, 2148, 2184,  228,    0,  252,  261, 2184, 2184,
     2184,    0,  267,  256, 2131, 2129, 2123, 2127, 2123, 2124,
     2123,  226, 2113,  242, 2107, 2111, 2116,  184, 2119,    0,
     2109, 2103, 2105, 2105,    0, 2102, 2102, 2096, 2111,  254,
     2090, 2093, 2099,    0,    0, 2092,  248, 2108,  254, 2089,
      140, 2099, 2094, 2088, 2089,  171,  303,  321,  366,  312,
      286,  301,  264,  290,  305,    0,  305,  311, 2184,  340,
      315,  324, 2095,  340, 2184, 2184, 2128, 2184, 2184,  316,
        0,    0,    0, 2102, 2101,  348,  351,  354,  333,  367,
      370, 2119, 2184, 2184,  378, 2184, 2184, 2124, 2184,    0,

     2079, 2085,  387,  396,  441, 2121,  393,  399,  409,  412,
      405,    0, 2067,    0,  407, 2066,  355, 2184,  294,    0,
        0,  442,  487,  402,  413, 2088,  304, 2083,  421,  359,
     2071, 2085, 2084,    0, 2087,    0, 2078, 2085,    0, 2080,
     2081,  389, 2082, 2077, 2078, 2075, 2064, 2072, 2072,    0,
     2075,    0, 2062, 2071, 2058, 2056, 2068, 2049,  543, 2049,
        0, 2066, 2048, 2063, 2058, 2052, 2058, 2050, 2040, 2039,
        0, 2039, 2049, 2037, 2040, 2040, 2034, 2039, 2040,    0,
      463, 2033, 2036, 2040, 2030, 2042,  467,  546,  406,  431,
      543,  446,  548, 2032, 2184,  535,    0, 2017,    0,  526,

     2016,  427, 2184,  563,  538,    0, 2023, 2030,  584, 2184,
     2184,  574,    0, 2013, 2184, 2035,  435, 2030,  532,  533,
     2018, 2032, 2008, 2184,  564,    0, 2052,  583, 2059,  620,
     2184,    0, 2027, 2020, 2017, 2016, 2019, 2014, 2023,  547,
     2021, 2024, 2006, 2007, 2003, 2007, 2009,    0, 2011, 1998,
     2008, 1995, 1995, 2013,    0,    0,    0,    0, 1993,    0,
        0, 1994,    0, 2003, 1998,  597, 1995, 2007,    0, 2002,
        0, 1997,    0, 1996, 2001, 2002, 1993, 1983, 1991, 1985,
     1995, 1991, 1973, 1977,    0, 1989,  623,  630, 1975, 1989,
     1977, 1989, 1972,  389,   58,  342,  603,  584,  604, 1983,

     1959, 2184, 1981,  596, 1976,  613,  589, 1964, 1978, 1954,
     2184,  620, 2184,  654,  631,    0,    0, 2184,  657,  660,
     1975, 1968, 1965, 1964, 1967, 1962, 1971,  595, 1969, 1972,
     1954,  430,  636,  621,  650,  649,  603,  557,  686, 1988,
      432, 1965, 1966, 1963, 1952, 1951, 1944, 1953, 1960, 1946,
     1941, 1941, 1939,    0,    0,    0,    0,    0, 1944, 1945,
     1951, 1937, 1951, 1933, 1947, 1946, 1937, 1929, 1930, 1932,
     1943, 1925, 1941, 1925, 1928, 1938, 1933, 1931, 1937,    0,
        0,    0, 1959, 1921, 1923, 1929, 1926, 1911,  609,  638,
      652,  678,  697,  643,  679,  692, 1925, 1918, 1915, 1914,

     1917, 1912, 1921,  660, 1919, 1922, 1904,  664,  665,  666,
      675,  678,  661,  677,  717, 2184,  720, 2184,  688, 1916,
     1917, 1914, 1903, 1902, 1895, 1904, 1911, 1897, 1892, 1892,
      681,  421,  688,  694,  685,  696,  707,  709,  686,  581,
      699, 1935,  745, 2184, 1891, 1908, 1887, 1906, 1887, 1886,
     1891, 1901, 1893, 1882, 1894, 1889,    0, 1876, 1876,    0,
     1891, 1886,    0, 1874,    0, 1891, 1888,  749, 1869,    0,
        0, 1884, 1883, 1868,    0,  752,    0, 1877, 1907,  756,
     1866, 1862,  709, 1869, 1872,  763, 2184,  764,  769,  755,
     1905,  757,  765,  771,  731, 1874, 1875, 1872, 1861, 1860,

     1853, 1862, 1869, 1855, 1850, 1850,  742,  737,  738,  739,
      741,  740,  751,  754,  756,  759,  744, 1850, 1867, 1846,
     1865, 1846, 1845, 1850, 1860, 1852, 1841, 1853, 1848,  757,
      758,  761,  766,  760,  762,  341,  767,  777,  765,  771,
      512, 1856, 1846, 1854, 1853, 1852, 1846, 1843, 1849, 1833,
     1843, 1831, 1840,    0,    0, 1839,    0, 1823, 1834,  822,
     2184, 1822,    0,    0,    0,  826, 2184, 1828,  826, 2184,
      833,  833, 1835, 1863, 1836, 1818, 1860,  817, 1859, 2184,
      838,  822,  840, 2184, 1858, 1814, 1831, 1810, 1829, 1810,
     1809, 1814, 1824, 1816, 1805, 1817, 1812,  800,  798,  814,

      813,  805,  806,  802,  818,  821,  815,  812,  816, 1820,
     1810, 1818, 1817, 1816, 1810, 1807, 1813, 1797, 1807, 1795,
      819,  836,  825,  838,  830,  832,  827,  850,  844,  839,
      849,  847,    0, 1794, 1808, 1807, 1806, 1800, 1804, 1800,
     1793, 1787,    0, 1781, 1796, 1793,    0,    0, 1822, 1791,
      885, 1790, 1819, 2184,  894, 1818,  905, 1792, 1782, 1790,
     1789, 1788, 1782, 1779, 1785, 1769, 1779, 1767,  845,  862,
      854,  865,  858,  867,  859,  882,  876,  870,  884,  883,
        0, 1766, 1780, 1779, 1778, 1772, 1776, 1772, 1765, 1759,
      891,  887,  897,  899,  900,  896,  895,  903,  890,  902,

      892, 1758,    0, 1771, 1770, 1769, 1750, 1767,    0, 1758,
     1746, 1789, 2184,  940, 1788,  958, 1787,  933, 1786, 2184,
     1785,    0, 1744, 1758, 1757, 1502, 1443, 1447, 1443, 1428,
     1422,  909,  908,  913,  921,  922,  924,  919,  933,  923,
      931,  927, 1416,    0, 1429, 1420, 1419, 1395, 1412, 1378,
      928,  939,  944,  945,  941,  953,  951,  948,  946, 1402,
     1401, 1400, 1399, 1395, 1386, 2184, 1415, 1374, 1413, 2184,
     1399, 1398, 2184,  983, 1396, 2184, 1356,    0, 1352, 1339,
     1276, 1255, 1272, 1243,  947,  963,  964,  965,  961,  968,
      967,  962,  966, 1270, 1269, 1268, 1265, 1261, 2184,  970,

     1232,  977,  978,  982,  981,  983, 1239, 1223, 1194, 1232,
     2184, 1173, 1209, 2184, 1010, 1180, 1176, 1172, 1138, 1046,
     2184,  972, 1016,  987,  988, 1001,  984, 1003, 1040, 1030,
     1004, 1007, 1008, 1014, 1017, 2184, 1017, 1043,  588,  546,
     1019, 1021, 1022, 1023, 1024, 1025, 1026,  433, 1063, 1027,
     1028, 1067,  334,  231,  190, 2184,   87, 2184, 2184, 1084,
     1100, 1116, 1132, 1148, 1164, 1180, 1194, 1198, 1213, 1220,
     1233, 1249, 1265, 1279, 1290, 1305, 1321, 1337, 1353, 1369,
     1376, 1049, 1380, 1186, 1384, 1391, 1396, 1190, 1400, 1272,
     1410, 1421, 1426, 1433, 1440, 1274, 1443, 1450, 1457, 1460,

     1467, 1480, 1496, 1512, 1528, 1544, 1560, 1576, 1592, 1608,
     1624, 1640, 1656, 1672, 1688, 1704, 1720, 1736, 1752, 1768
    } ;

static yyconst flex_int16_t yy_def[1021] =
    {   0,
      959,    1,  960,  960,  961,  961,  962,  962,  963,  963,
      964,  964,    1,    1,  959,  959,  959,  959,  959,  965,
      966,  967,  968,  959,  969,  959,  959,  959,  959,  959,
      959,  959,  970,  959,  959,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  959,  959,  959,  966,  971,  959,  972,
      971,  971,  973,  959,  959,  974,  975,  976,  977,  959,
      974,  975,  976,  978,  959,  976,  979,  959,  959,  970,
      970,  970,  959,  966,  959,  959,  965,  959,  959,  980,
      966,  959,  959,  959,  959,  981,  982,  983,  983,  984,

      969,  959,  959,  959,  959,  985,  959,  986,  959,  959,
      959,  970,  959,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  959,  959,  966,  966,
      966,  966,  966,  966,  966,  971,  972,  972,  959,  971,
      971,  971,  971,  973,  959,  959,  959,  959,  959,  959,
      987,  988,  989,  989,  990,  959,  959,  959,  959,  991,
      977,  959,  959,  959,  978,  959,  959,  979,  959,  970,

      970,  970,  959,  959,  966,  959,  959,  959,  959,  992,
      959,  981,  993,  983,  983,  994,  994,  959,  959,  995,
      996,  986,  959,  986,  959,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  959,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  158,
      959,  959,  959,  959,  959,  959,  966,  966,  966,  966,
      966,  966,  966,  971,  959,  959,  987,  997,  989,  989,

      998,  998,  959,  959,  959,  999,  970,  970,  959,  959,
      959,  959, 1000,  993,  959,  983,  983,  983,  983,  983,
      983,  983,  994,  959,  994,  995, 1001,  986, 1002, 1002,
      959,  223,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  959,  959,  959,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  959,  959,  959,  959,
      959,  959,  959, 1003,  966,  966,  966,  966,  966,  971,

      997,  959,  989,  989,  989,  989,  989,  989,  989,  998,
      959,  998,  959,  959,  959,  970,  970,  959,  959,  959,
      983,  983,  983,  983,  983,  983,  983,  983,  983,  983,
      983,  994,  994,  994,  994,  994,  994,  994, 1004, 1001,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  959,  959,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970, 1005,  959,  959,  959,  959,  959, 1003, 1006,
      966,  966,  966,  966,  966,  971,  989,  989,  989,  989,

      989,  989,  989,  989,  989,  989,  989,  998,  998,  998,
      998,  998,  998,  998,  959,  959,  959,  959,  983,  983,
      983,  983,  983,  983,  983,  983,  983,  983,  983,  983,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994, 1004, 1004,  959,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  959,  959,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  970, 1005, 1007,
      959,  959,  959,  959,  959, 1006,  959, 1006,  966,  966,
     1008,  966,  966, 1009,  989,  989,  989,  989,  989,  989,

      989,  989,  989,  989,  989,  989,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  983,  983,  983,
      983,  983,  983,  983,  983,  983,  983,  983,  983,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  970,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  970,  970,  970,  959,  959,  959,
      959,  970,  970,  970,  970,  959,  959,  970, 1007,  959,
     1007,  959,  959, 1010,  959,  959, 1011,  966, 1008,  959,
      966,  966, 1009,  959, 1010,  989,  989,  989,  989,  989,
      989,  989,  989,  989,  989,  989,  989,  998,  998,  998,

      998,  998,  998,  998,  998,  998,  998,  998,  998,  983,
      983,  983,  983,  983,  983,  983,  983,  983,  983,  983,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  970,  970,  970,  970,  970,  970,  970,  970,
      970,  970,  970,  970,  959,  959,  970,  970, 1012,  959,
      959,  959, 1011,  959,  966, 1013,  966,  989,  989,  989,
      989,  989,  989,  989,  989,  989,  989,  989,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      983,  983,  983,  983,  983,  983,  983,  983,  983,  983,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  994,

      994,  970,  970,  970,  970,  970,  970,  970,  970,  959,
      959, 1012,  959,  959, 1014,  959, 1015,  966, 1013,  959,
     1016,  989,  989,  989,  989,  989,  989,  989,  989,  989,
      989,  998,  998,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  983,  983,  983,  983,  983,  983,  983,  994,
      994,  994,  994,  994,  994,  994,  994,  994,  994,  970,
      970,  970,  970,  970,  959,  959, 1017,  959, 1014,  959,
     1018, 1015,  959,  966, 1016,  959,  989,  989,  989,  989,
      989,  989,  989,  998,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  983,  983,  983,  983,  983,  959,  994,

      994,  994,  994,  994,  994,  994,  970,  970,  959, 1017,
      959,  959, 1018,  959,  966,  989,  989,  989,  989,  989,
      959,  998,  998,  998,  998,  998,  998,  998,  983,  983,
      994,  994,  994,  994,  994,  959,  959,  966,  989,  989,
      998,  998,  998,  998,  998,  994,  994,  959,  966,  998,
      998,  959, 1019, 1020, 1019,  959, 1020,  959,    0,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,

      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959
    } ;

static yyconst flex_int16_t yy_nxt[2242] =
    {   0,
       16,   17,   18,   17,   19,   20,   21,   22,   23,   24,
       25,   16,   16,   16,   26,   27,   28,   29,   29,   30,
       31,   32,   33,   33,   33,   34,   35,   36,   37,   38,
       39,   40,   41,   42,   33,   33,   43,   33,   33,   44,
       45,   46,   47,   48,   33,   49,   50,   51,   33,   52,
       53,   33,   33,   16,   54,   16,   55,   56,   59,   56,
       92,   85,   57,   85,   61,   59,   61,   64,   60,   62,
       65,   64,   66,   67,   65,   60,   66,   67,   70,   78,
       70,   78,   75,   71,   72,   71,   72,   66,   67,  958,
       68,   75,   80,   83,   68,   83,   66,   67,   84,   81,

      491,   73,   79,   73,   79,   76,   88,   82,   89,   89,
       93,   99,  108,  109,   76,   94,  105,  105,  113,  113,
       80,   95,   95,  119,  106,  122,   90,   81,  107,  107,
      107,  115,  116,  138,  124,   82,  120,  100,  125,  123,
      117,  127,  118,  121,  126,  146,  135,  139,  150,  130,
      128,  106,  129,  136,  131,  132,  140,   97,  133,  141,
      144,  134,  147,  151,  145,  148,  152,  153,  272,  142,
      154,  157,  172,  157,  172,  143,  158,  159,   92,  159,
      168,  179,  170,  169,  170,  273,  175,  171,  176,  176,
      178,  179,  956,  160,  160,  959,  188,  189,  189,  192,

      184,  180,  180,  278,  193,  193,  177,  279,  161,  187,
      173,   85,  162,   85,  184,  163,  178,  959,  208,  164,
      248,  165,  193,  188,  189,  189,  185,  180,  180,  196,
      249,  190,  209,  958,  197,  197,  146,  182,  115,  116,
      185,  188,  189,  189,  219,  219,  203,  117,  203,  118,
      202,  204,  197,  147,  200,  259,  148,  259,  190,  211,
      211,  211,   88,  182,   89,   89,   92,  210,  107,  107,
      107,  221,  240,  241,  222,  243,  190,  205,   92,  205,
      264,  244,  206,  225,  225,  225,  224,  226,   92,  227,
      265,  267,   92,  160,  160,  228,  229,  268,  269,  230,

      291,  270,  231,   92,  157,  232,  157,   92,  161,  158,
      219,  219,  162,  287,   92,  287,  172,  959,  172,  164,
      959,  165,  280,  168,  280,  172,  169,  172,  288,  288,
      288,  289,  296,  296,  296,  292,  956,  293,  281,  281,
      334,  170,  290,  170,   92,  175,  171,  176,  176,  305,
      305,  305,  335,  282,  173,  303,  303,  283,  303,  303,
      284,  303,  303,  173,  285,  177,  286,  159,   92,  159,
      304,  304,  192,  303,  303,  303,  303,  193,  193,  303,
      196,  492,  325,  160,  160,  197,  197,  340,  203,  727,
      203,   92,  303,  204,  490,  193,  324,  309,  161,  309,

      311,  311,  162,  197,  341,  163,  311,  311,   92,  164,
      324,  165,  959,  281,  281,  959,  311,  311,  311,  311,
      311,  211,  211,  211,  311,  312,  312,  959,  282,  225,
      225,  225,  283,   92,  311,  350,  351,  311,  316,  285,
      317,  286,  205,   92,  205,  328,  318,  319,   92,  337,
      320,  395,  221,  321,  412,  959,  322,  338,  160,  160,
      631,  396,  531,  339,  387,  952,  387,  224,  287,   92,
      287,  422,  394,  161,  398,  545,  324,  162,  231,  388,
      388,  388,  411,  423,  164,  324,  165,  329,  330,  331,
      330,  329,  329,  329,  329,  329,  329,  329,  329,  329,

      329,  329,  329,  332,  332,  332,  329,  329,  329,  332,
      332,  332,  329,  329,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      332,  332,  332,  332,  332,  332,  332,  332,  332,  332,
      329,  329,  329,  329,  366,   92,  366,  287,   92,  287,
       92,  296,  296,  296,  305,  305,  305,  403,  732,  404,
      425,  428,  288,  288,  288,  405,  406,  324,  426,  407,
      413,  413,  408,  822,  427,  409,  367,  448,  429,  414,
      414,  418,  418,  368,  397,  309,   92,  309,  413,  541,
      419,  419,  399,  221,  449,  432,  959,  433,  366,  418,

      366,  281,  281,  434,  435,   92,   92,  436,  224,  640,
      437,   92,  324,  438,  490,  822,  282,  504,  494,  324,
      283,  330,  331,  330,  387,  526,  387,  285,  483,  286,
      367,  387,  498,  387,  505,  493,  324,  368,  516,  516,
      587,  501,  527,  588,  499,   92,  388,  388,  388,  502,
      540,  508,  495,  509,   92,  503,  516,  534,  324,  510,
      511,  413,  413,  512,  418,  418,  513,  518,  518,  514,
      515,  515,  532,  517,  517,  411,  324,  538,  535,  413,
       92,   92,  418,  592,  533,  518,  536,  543,  544,  543,
      602,  324,  537,  594,  539,  594,  607,  589,  591,   92,

      591,  608,  610,  611,  324,  324,  614,  603,  616,  617,
      674,  612,  674,  609,  630,  593,  411,  613,  639,  411,
      411,  411,  634,  615,  413,  413,  590,  418,  418,  632,
      411,  618,  411,  411,  321,  633,  324,  635,  636,  637,
      324,  324,  413,  324,  641,  418,  543,  544,  543,  324,
      660,  324,  660,  666,  324,  666,  638,   92,  670,   92,
      661,  671,  324,  667,  324,  587,  587,   92,  588,  588,
      677,   92,  677,  684,  686,  698,  699,  408,  702,  700,
      701,  703,  704,  685,  705,  681,  678,  708,  707,  709,
      722,  723,  411,  411,  411,  411,  411,  411,  724,  411,

      721,  706,  725,  437,  726,  728,  411,  729,  730,  411,
      682,  411,  324,  324,  411,  324,  324,  324,  731,   92,
      324,  324,  324,  660,   92,  660,  324,  666,  670,  666,
      770,  671,  324,  661,  749,  670,  749,  667,  671,  756,
       92,  756,  684,  769,  771,  772,  513,  773,  774,  755,
      775,  777,  685,  411,  757,  411,  776,  411,  778,  779,
      411,  411,  780,  791,  539,  793,  796,  411,  411,  411,
      411,  411,  792,  411,  324,  794,  411,  795,  797,  798,
      324,  800,  324,  801,  799,  324,  815,  324,  815,  832,
      615,  324,  834,  324,  324,  817,   92,  817,  837,  324,

      411,  833,  324,  835,  324,  324,  821,   92,  821,  411,
      838,  839,  836,  411,  411,  840,  841,  411,  850,  842,
      411,  818,  411,  851,  850,  411,  852,  853,  854,  855,
      856,  411,  857,  858,  859,   92,  884,  411,  411,  411,
      884,  867,  324,  867,  885,  324,  324,  324,  886,  887,
      324,  324,  324,  889,  324,  324,  888,  324,  324,  871,
      890,  871,  892,  411,  411,  891,  901,  868,  411,  893,
      900,  901,  902,  903,  411,  874,  411,  411,  411,  411,
      901,  904,  411,  324,  905,   92,  411,  906,  411,  922,
      923,  923,  924,  925,  324,  923,  324,  926,  927,  324,

      324,  324,  411,  324,  850,  932,  324,  928,  324,  933,
      935,  931,   92,  941,  884,  942,  411,  411,  411,  411,
      411,  411,  411,  411,  915,  324,  934,  411,  943,  944,
      945,  946,  324,  324,  901,  850,  324,  324,  324,  411,
      938,  947,  411,  411,  901,   92,  950,  948,  923,  884,
      951,  923,  850,  850,  884,  884,  411,  781,  411,  324,
      213,  213,  324,  324,  953,   92,  953,  781,  954,  324,
      954,  921,  324,  878,  411,  949,  411,  411,  411,  411,
      324,  324,  411,  411,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,

       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   87,  940,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
       91,   91,   91,   91,   91,   91,   96,  216,  216,  822,

       96,  298,  298,  878,   96,   96,   96,  939,   96,   98,
       98,  914,   98,  101,  937,  101,  101,  101,  101,  101,
      101,  101,  101,  101,  101,  101,  101,  101,  101,  112,
      112,  112,  112,  166,  911,  166,  166,  166,  166,  166,
      936,  166,  166,  166,  166,  166,  166,  166,  166,  167,
      733,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  174,  733,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  181,  181,  301,  301,  327,  327,  899,  844,  181,
      181,  181,  930,  181,  183,  781,  844,  929,  921,  920,

      919,  183,  183,  918,  183,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  191,  191,  191,  191,  191,  191,  191,  191,  191,
      191,  191,  191,  191,  191,  191,  191,  195,  195,  195,
      195,  195,  195,  195,  195,  195,  195,  195,  195,  195,
      195,  195,  195,  198,  198,  198,  198,  198,  198,  198,
      198,  198,  198,  198,  198,  198,  917,  198,  198,  207,
      207,  207,  207,  207,  207,  207,  207,  207,  207,  822,
      207,  207,  207,  207,  207,  212,  212,  212,  212,  214,
      214,  214,  214,  220,  220,  220,  223,  916,  876,  223,

      873,  914,  223,  223,  223,  297,  297,  297,  297,  299,
      299,  299,  299,  306,  306,  870,  912,  911,  909,  306,
      306,  306,  803,  306,  313,  313,  908,  733,  803,  907,
      313,  313,  313,  899,  313,  314,  314,  314,  314,  898,
      897,  314,  323,  323,  323,  323,  896,  895,  323,  326,
      326,  326,  401,  401,  401,  401,  781,  894,  401,  410,
      410,  410,  410,  883,  882,  410,  415,  415,  415,  420,
      420,  420,  440,  881,  878,  880,  440,  440,  440,  440,
      329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
      329,  329,  329,  329,  329,  329,  489,  489,  489,  489,

      489,  489,  489,  489,  489,  489,  489,  489,  489,  489,
      489,  489,  542,  542,  542,  542,  542,  542,  542,  542,
      542,  542,  542,  542,  542,  542,  542,  542,  579,  879,
      579,  579,  579,  579,  579,  579,  579,  579,  579,  579,
      579,  579,  579,  579,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      669,  669,  669,  669,  669,  669,  669,  669,  669,  669,
      669,  669,  669,  669,  669,  669,  679,  679,  679,  679,
      679,  679,  679,  679,  679,  679,  679,  679,  679,  679,
      679,  679,  683,  683,  683,  683,  683,  683,  683,  683,

      683,  683,  683,  683,  683,  683,  683,  683,  685,  685,
      685,  685,  685,  685,  685,  685,  685,  685,  685,  685,
      685,  685,  685,  685,  753,  753,  753,  753,  753,  753,
      753,  753,  753,  753,  753,  753,  753,  753,  753,  753,
      812,  812,  812,  812,  812,  812,  812,  812,  812,  812,
      812,  812,  812,  812,  812,  812,  819,  819,  819,  819,
      819,  819,  819,  819,  819,  819,  819,  819,  819,  819,
      819,  819,  869,  869,  869,  869,  869,  869,  869,  869,
      869,  869,  869,  869,  869,  869,  869,  869,  872,  872,
      872,  872,  872,  872,  872,  872,  872,  872,  872,  872,

      872,  872,  872,  872,  875,  875,  875,  875,  875,  875,
      875,  875,  875,  875,  875,  875,  875,  875,  875,  875,
      910,  910,  910,  910,  910,  910,  910,  910,  910,  910,
      910,  910,  910,  910,  910,  910,  913,  913,  913,  913,
      913,  913,  913,  913,  913,  913,  913,  913,  913,  913,
      913,  913,  955,  955,  955,  955,  955,  955,  955,  955,
      955,  955,  955,  955,  955,  955,  955,  955,  957,  957,
      957,  957,  957,  957,  957,  957,  957,  957,  957,  957,
      957,  957,  957,  957,  878,  878,  877,  876,  820,  873,
      870,  813,  866,  865,  864,  863,  862,  861,  733,  860,

      849,  848,  847,  844,  846,  845,  844,  844,  843,  831,
      830,  829,  828,  827,  826,  825,  824,  822,  823,  822,
      820,  754,  816,  814,  813,  811,  810,  809,  808,  807,
      806,  803,  805,  804,  803,  803,  802,  790,  789,  788,
      787,  786,  785,  784,  783,  781,  782,  781,  768,  767,
      766,  765,  764,  763,  762,  761,  760,  759,  758,  505,
      684,  680,  754,  752,  751,  684,  750,  748,  747,  746,
      745,  744,  743,  742,  741,  740,  739,  738,  737,  736,
      735,  733,  734,  733,  720,  719,  718,  717,  716,  715,
      714,  713,  712,  711,  710,  429,  697,  696,  695,  694,

      693,  692,  691,  690,  689,  688,  687,  680,  676,  675,
      673,  672,  580,  668,  665,  664,  663,  662,  659,  658,
      657,  656,  655,  654,  653,  652,  651,  650,  649,  648,
      647,  646,  645,  644,  643,  642,  341,  544,  629,  628,
      627,  626,  625,  624,  623,  622,  621,  620,  619,  606,
      605,  604,  601,  600,  599,  598,  597,  596,  595,  585,
      584,  583,  582,  581,  580,  578,  577,  576,  575,  574,
      573,  572,  571,  570,  569,  568,  567,  566,  565,  564,
      563,  562,  561,  560,  559,  558,  557,  556,  555,  554,
      553,  552,  551,  550,  549,  548,  547,  546,  439,  530,

      529,  528,  525,  524,  523,  522,  521,  520,  519,  411,
      507,  506,  500,  497,  402,  496,  488,  487,  486,  485,
      484,  482,  481,  480,  479,  478,  477,  476,  475,  474,
      473,  472,  471,  470,  469,  468,  467,  466,  465,  464,
      463,  462,  461,  460,  459,  458,  457,  456,  455,  454,
      453,  452,  451,  450,  447,  446,  445,  444,  443,  442,
      441,  331,  439,  324,  431,  430,  424,  421,  315,  417,
      416,  411,  402,  400,  393,  392,  391,  390,  389,  386,
      385,  384,  383,  382,  381,  380,  379,  378,  377,  376,
      375,  374,  373,  372,  371,  370,  369,  365,  364,  363,

      362,  361,  360,  359,  358,  357,  356,  355,  354,  353,
      352,  349,  348,  347,  346,  345,  344,  343,  342,  336,
      333,  324,  315,  310,  308,  307,  199,  194,  302,  300,
      295,  294,  277,  276,  275,  274,  271,  266,  263,  262,
      261,  260,  258,  257,  256,  255,  254,  253,  252,  251,
      250,  247,  246,  245,  242,  239,  238,  237,  236,  235,
      234,  233,  218,  102,  217,  215,   92,  201,  199,  194,
      156,  155,  149,  137,  114,  111,  110,  104,  103,  102,
       92,   86,  959,   15,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,

      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959
    } ;

static yyconst flex_int16_t yy_chk[2242] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    2,    3,    2,
      395,   17,    2,   17,    4,    4,    4,    5,    3,    4,
        5,    6,    5,    5,    6,    4,    6,    6,    7,   11,
        8,   12,    9,    7,    7,    8,    8,    9,    9,  957,
        5,   10,   13,   14,    6,   14,   10,   10,   14,   13,

      395,    7,   11,    8,   12,    9,   20,   13,   20,   20,
       22,   23,   30,   30,   10,   22,   28,   28,   34,   34,
       14,   22,   22,   38,   28,   39,   20,   14,   29,   29,
       29,   37,   37,   45,   40,   14,   38,   23,   40,   39,
       37,   41,   37,   38,   40,   48,   43,   45,   50,   42,
       41,   28,   41,   43,   42,   42,   45,   22,   42,   46,
       47,   42,   48,   50,   47,   48,   50,   51,  151,   46,
       51,   56,   62,   56,   62,   46,   56,   57,   57,   57,
       60,   67,   61,   60,   61,  151,   63,   61,   63,   63,
       66,   66,  955,   57,   57,   72,   73,   73,   73,   69,

       67,   66,   66,  156,   69,   69,   63,  156,   57,   68,
       62,   85,   57,   85,   72,   57,   71,   71,   90,   57,
      128,   57,   69,   68,   68,   68,   67,   71,   71,   74,
      128,   73,   90,  954,   74,   74,   82,   66,   80,   80,
       72,   76,   76,   76,  105,  105,   83,   80,   83,   80,
       82,   83,   74,   82,   80,  140,   82,  140,   68,   95,
       95,   95,   87,   71,   87,   87,  163,   90,  107,  107,
      107,  108,  122,  122,  108,  124,   76,   84,   84,   84,
      147,  124,   87,  113,  113,  113,  108,  114,  161,  114,
      147,  149,  164,   84,   84,  114,  114,  149,  149,  114,

      163,  149,  114,  162,  157,  114,  157,  165,   84,  157,
      219,  219,   84,  160,  160,  160,  171,  167,  171,   84,
      167,   84,  158,  168,  158,  172,  168,  172,  160,  160,
      160,  161,  180,  180,  180,  164,  953,  165,  158,  158,
      227,  170,  162,  170,  396,  174,  170,  174,  174,  189,
      189,  189,  227,  158,  171,  186,  186,  158,  187,  187,
      158,  188,  188,  172,  158,  174,  158,  159,  159,  159,
      188,  188,  191,  186,  190,  190,  187,  191,  191,  188,
      195,  396,  217,  159,  159,  195,  195,  230,  203,  636,
      203,  394,  190,  203,  394,  191,  636,  204,  159,  204,

      207,  207,  159,  195,  230,  159,  208,  208,  289,  159,
      217,  159,  224,  204,  204,  224,  209,  209,  207,  210,
      210,  211,  211,  211,  208,  209,  209,  224,  204,  225,
      225,  225,  204,  290,  209,  242,  242,  210,  215,  204,
      215,  204,  205,  205,  205,  222,  215,  215,  292,  229,
      215,  289,  222,  215,  302,  222,  215,  229,  205,  205,
      532,  290,  432,  229,  281,  948,  281,  222,  287,  287,
      287,  317,  287,  205,  292,  441,  532,  205,  441,  281,
      281,  281,  302,  317,  205,  432,  205,  223,  223,  223,
      223,  223,  223,  223,  223,  223,  223,  223,  223,  223,

      223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
      223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
      223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
      223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
      223,  223,  223,  223,  259,  291,  259,  288,  288,  288,
      293,  296,  296,  296,  305,  305,  305,  300,  641,  300,
      319,  320,  288,  288,  288,  300,  300,  641,  319,  300,
      304,  304,  300,  940,  319,  300,  259,  340,  320,  304,
      304,  312,  312,  259,  291,  309,  398,  309,  304,  438,
      312,  312,  293,  328,  340,  325,  328,  325,  366,  312,

      366,  309,  309,  325,  325,  397,  399,  325,  328,  540,
      325,  489,  438,  325,  489,  939,  309,  407,  398,  325,
      309,  330,  330,  330,  387,  428,  387,  309,  387,  309,
      366,  388,  404,  388,  407,  397,  540,  366,  415,  415,
      490,  406,  428,  490,  404,  494,  388,  388,  388,  406,
      437,  412,  399,  412,  491,  406,  415,  434,  437,  412,
      412,  414,  414,  412,  419,  419,  412,  420,  420,  412,
      414,  414,  433,  419,  419,  412,  434,  436,  435,  414,
      492,  495,  419,  494,  433,  420,  435,  439,  439,  439,
      504,  433,  435,  496,  436,  496,  508,  491,  493,  493,

      493,  509,  510,  511,  436,  435,  512,  504,  513,  514,
      583,  511,  583,  509,  531,  495,  513,  511,  539,  508,
      509,  510,  535,  512,  515,  515,  492,  517,  517,  533,
      511,  519,  514,  512,  519,  534,  531,  536,  537,  538,
      535,  539,  515,  533,  541,  517,  543,  543,  543,  534,
      568,  536,  568,  576,  541,  576,  538,  590,  580,  592,
      568,  580,  537,  576,  538,  586,  588,  593,  586,  588,
      589,  589,  589,  594,  595,  607,  608,  595,  611,  609,
      610,  612,  613,  594,  614,  592,  590,  616,  615,  617,
      631,  632,  608,  609,  610,  612,  611,  607,  633,  617,

      630,  614,  634,  630,  635,  637,  613,  638,  639,  614,
      593,  615,  630,  631,  616,  634,  632,  635,  640,  678,
      639,  633,  637,  660,  682,  660,  640,  666,  669,  666,
      699,  669,  638,  660,  672,  671,  672,  666,  671,  681,
      681,  681,  683,  698,  700,  701,  698,  702,  703,  678,
      704,  706,  683,  699,  682,  698,  705,  704,  707,  708,
      702,  703,  709,  722,  721,  724,  727,  708,  701,  700,
      707,  709,  723,  705,  721,  725,  706,  726,  728,  729,
      723,  731,  727,  732,  730,  725,  751,  726,  751,  770,
      769,  722,  772,  724,  730,  755,  755,  755,  775,  729,

      769,  771,  732,  773,  731,  728,  757,  757,  757,  771,
      776,  777,  774,  773,  775,  778,  779,  770,  791,  780,
      772,  755,  774,  792,  793,  778,  794,  795,  796,  797,
      798,  777,  799,  800,  801,  818,  832,  776,  780,  779,
      834,  814,  792,  814,  833,  799,  791,  801,  835,  836,
      797,  796,  793,  838,  794,  795,  837,  800,  798,  816,
      839,  816,  841,  833,  832,  840,  852,  814,  834,  842,
      851,  853,  854,  855,  838,  818,  835,  836,  840,  837,
      856,  857,  842,  851,  858,  874,  841,  859,  839,  885,
      886,  887,  888,  889,  852,  890,  855,  891,  892,  853,

      854,  859,  885,  858,  902,  903,  857,  893,  856,  904,
      906,  900,  915,  922,  924,  925,  889,  892,  886,  887,
      888,  893,  891,  890,  874,  900,  905,  922,  926,  927,
      928,  931,  902,  903,  932,  933,  905,  904,  906,  927,
      915,  934,  924,  925,  935,  938,  941,  937,  942,  943,
      944,  945,  946,  947,  950,  951,  926,  930,  928,  931,
      982,  982,  932,  933,  949,  949,  949,  929,  952,  934,
      952,  923,  935,  920,  941,  938,  942,  943,  944,  945,
      946,  947,  950,  951,  960,  960,  960,  960,  960,  960,
      960,  960,  960,  960,  960,  960,  960,  960,  960,  960,

      961,  961,  961,  961,  961,  961,  961,  961,  961,  961,
      961,  961,  961,  961,  961,  961,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  963,  963,  963,  963,  963,  963,  963,  963,
      963,  963,  963,  963,  963,  963,  963,  963,  964,  964,
      964,  964,  964,  964,  964,  964,  964,  964,  964,  964,
      964,  964,  964,  964,  965,  919,  965,  965,  965,  965,
      965,  965,  965,  965,  965,  965,  965,  965,  965,  965,
      966,  966,  966,  966,  966,  966,  966,  966,  966,  966,
      966,  966,  966,  966,  966,  966,  967,  984,  984,  918,

      967,  988,  988,  917,  967,  967,  967,  916,  967,  968,
      968,  913,  968,  969,  912,  969,  969,  969,  969,  969,
      969,  969,  969,  969,  969,  969,  969,  969,  969,  970,
      970,  970,  970,  971,  910,  971,  971,  971,  971,  971,
      909,  971,  971,  971,  971,  971,  971,  971,  971,  972,
      908,  972,  972,  972,  972,  972,  972,  972,  972,  972,
      972,  972,  972,  972,  972,  973,  907,  973,  973,  973,
      973,  973,  973,  973,  973,  973,  973,  973,  973,  973,
      973,  974,  974,  990,  990,  996,  996,  901,  898,  974,
      974,  974,  897,  974,  975,  896,  895,  894,  884,  883,

      882,  975,  975,  881,  975,  976,  976,  976,  976,  976,
      976,  976,  976,  976,  976,  976,  976,  976,  976,  976,
      976,  977,  977,  977,  977,  977,  977,  977,  977,  977,
      977,  977,  977,  977,  977,  977,  977,  978,  978,  978,
      978,  978,  978,  978,  978,  978,  978,  978,  978,  978,
      978,  978,  978,  979,  979,  979,  979,  979,  979,  979,
      979,  979,  979,  979,  979,  979,  880,  979,  979,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  980,  879,
      980,  980,  980,  980,  980,  981,  981,  981,  981,  983,
      983,  983,  983,  985,  985,  985,  986,  877,  875,  986,

      872,  871,  986,  986,  986,  987,  987,  987,  987,  989,
      989,  989,  989,  991,  991,  869,  868,  867,  865,  991,
      991,  991,  864,  991,  992,  992,  863,  862,  861,  860,
      992,  992,  992,  850,  992,  993,  993,  993,  993,  849,
      848,  993,  994,  994,  994,  994,  847,  846,  994,  995,
      995,  995,  997,  997,  997,  997,  845,  843,  997,  998,
      998,  998,  998,  831,  830,  998,  999,  999,  999, 1000,
     1000, 1000, 1001,  829,  828,  827, 1001, 1001, 1001, 1001,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1003, 1003, 1003, 1003,

     1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003,
     1003, 1003, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1005,  826,
     1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005,
     1005, 1005, 1005, 1005, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
     1007, 1007, 1007, 1007, 1007, 1007, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
     1008, 1008, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,

     1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1011, 1011, 1011, 1011, 1011, 1011,
     1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
     1012, 1012, 1012, 1012, 1012, 1012, 1013, 1013, 1013, 1013,
     1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
     1013, 1013, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1015, 1015,
     1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015,

     1015, 1015, 1015, 1015, 1016, 1016, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016,
     1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017,
     1017, 1017, 1017, 1017, 1017, 1017, 1018, 1018, 1018, 1018,
     1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 1018,
     1018, 1018, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019,
     1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 1020, 1020,
     1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
     1020, 1020, 1020, 1020,  825,  824,  823,  821,  819,  817,
      815,  812,  811,  810,  808,  807,  806,  805,  804,  802,

      790,  789,  788,  787,  786,  785,  784,  783,  782,  768,
      767,  766,  765,  764,  763,  762,  761,  760,  759,  758,
      756,  753,  752,  750,  749,  746,  745,  744,  742,  741,
      740,  739,  738,  737,  736,  735,  734,  720,  719,  718,
      717,  716,  715,  714,  713,  712,  711,  710,  697,  696,
      695,  694,  693,  692,  691,  690,  689,  688,  687,  686,
      685,  679,  677,  676,  675,  674,  673,  668,  662,  659,
      658,  656,  653,  652,  651,  650,  649,  648,  647,  646,
      645,  644,  643,  642,  629,  628,  627,  626,  625,  624,
      623,  622,  621,  620,  619,  618,  606,  605,  604,  603,

      602,  601,  600,  599,  598,  597,  596,  591,  585,  584,
      582,  581,  579,  578,  574,  573,  572,  569,  567,  566,
      564,  562,  561,  559,  558,  556,  555,  554,  553,  552,
      551,  550,  549,  548,  547,  546,  545,  542,  530,  529,
      528,  527,  526,  525,  524,  523,  522,  521,  520,  507,
      506,  505,  503,  502,  501,  500,  499,  498,  497,  488,
      487,  486,  485,  484,  483,  479,  478,  477,  476,  475,
      474,  473,  472,  471,  470,  469,  468,  467,  466,  465,
      464,  463,  462,  461,  460,  459,  453,  452,  451,  450,
      449,  448,  447,  446,  445,  444,  443,  442,  440,  431,

      430,  429,  427,  426,  425,  424,  423,  422,  421,  410,
      409,  408,  405,  403,  401,  400,  393,  392,  391,  390,
      389,  386,  384,  383,  382,  381,  380,  379,  378,  377,
      376,  375,  374,  372,  370,  368,  367,  365,  364,  362,
      359,  354,  353,  352,  351,  350,  349,  347,  346,  345,
      344,  343,  342,  341,  339,  338,  337,  336,  335,  334,
      333,  329,  327,  323,  322,  321,  318,  316,  314,  308,
      307,  301,  298,  294,  286,  285,  284,  283,  282,  279,
      278,  277,  276,  275,  274,  273,  272,  270,  269,  268,
      267,  266,  265,  264,  263,  262,  260,  258,  257,  256,

      255,  254,  253,  251,  249,  248,  247,  246,  245,  244,
      243,  241,  240,  238,  237,  235,  233,  232,  231,  228,
      226,  216,  213,  206,  202,  201,  198,  192,  185,  184,
      177,  173,  155,  154,  153,  152,  150,  148,  146,  143,
      142,  141,  139,  138,  137,  136,  134,  133,  132,  131,
      129,  127,  126,  125,  123,  121,  120,  119,  118,  117,
      116,  115,  103,  101,  100,   99,   91,   81,   77,   70,
       53,   52,   49,   44,   36,   32,   31,   27,   26,   25,
       21,   19,   15,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,

      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959,  959,  959,  959,  959,  959,  959,  959,  959,  959,
      959
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 1;

static yyconst flex_int16_t yy_rule_linenum[143] =
    {   0,
      466,  467,  468,  469,  470,  472,  488,  491,  495,  500,
      503,  506,  513,  514,  516,  517,  518,  519,  520,  521,
      522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
      532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
      542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
      552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
      562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
      602,  610,  611,  612,  613,  615,  618,  621,  624,  627,
      631,  635,  639,  644,  647,  650,  653,  656,  658,  670,
      682,  684,  688,  691,  695,  696,  697,  699,  736,  737,

      738,  741,  743,  748,  753,  758,  763,  768,  772,  773,
      778,  783,  788,  791,  796,  799,  804,  809,  810,  851,
      874,  883,  888,  893,  896,  918,  939,  956,  957,  958,
      959,  960,  961,  962,  963,  964,  965,  966,  967,  968,
      969,  971
    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lex.l"

#line 26 "lex.l"
#include <sys/types.h>	
#include <sys/stat.h>
#include "mailfromd.h"
#include "dirname.h"
#include "gram.h"
#include "prog.h"

static struct locus locus; /* Current input location */
static struct locus start_locus; /* Location when the last state switch
				    occurred */
static struct obstack string_stk; /* Obstack for constructing string values */
static char *multiline_delimiter; /* End of here-document delimiter */ 
static size_t multiline_delimiter_len; /* Length of multiline_delimiter_len */
static int multiline_unescape;         /* Unescape here-document contents */
static int (*char_to_strip)(char);     /* Strip matching characters of each
					  here-document line */

int paren_follows = 0;  /* Tie-in used by the grammar to emit deprecation
                           warnings about function names being used as
                           prefix operators. */

static int
is_tab(char c)
{
	return c == '\t';
}
 
static int
is_space(char c)
{
	return c == '\t' || c == ' ';
}

#define line_begin string_begin
#define line_add string_add
#define line_add_char string_add_char
static void line_finish(void);
static void string(const char *str, size_t len);
static int isemptystr(char *text);
static int builtin_const(const char *s, size_t len);

/* External interface to locus */ 
const struct locus *
get_locus()
{
	return &locus;
}


/* Input context flags */
#define INCTX_MODULE     0x1  /* current input is a MFL module */
#define INCTX_HADINPUT   0x2  /* some statements has already been processed */
#define INCTX_IGNORE_BYE 0x4  /* ignore eventual `bye' statement, because
                                 this is an #included module */

/* Input context stack */
struct inctx {                     /* input context structure */
	struct inctx *parent;      /* parent context */
	struct locus locus;        /* locus where the context was pushed */
	struct input_file_ident id;/* file id structure to prevent recursion */
	FILE *file;                /* saved yyin */ 
	pid_t pp_pid;              /* preprocessor pid, if used */
	int inctx_flags;           /* input context flags */ 
	YY_BUFFER_STATE buf;       /* lex buffer state */
};

struct inctx *inctx_tos;           /* stack of input contexts */

/* Current input context: */
static pid_t pp_pid;               /* preprocessor pid */
static struct input_file_ident input_file_id;
static int inctx_flags;            /* input context flags */

/* If not 0, emit_token keeps a token that yylex must return on the
   next call. See YY_USER_ACTION below. */
static int emit_token;

/* Find on stack an input context that matches the given file id.
   Return pointer to the context. */
struct inctx *
inctx_locate(struct input_file_ident *id)
{
	struct inctx *ctx;

	for (ctx = inctx_tos; ctx; ctx = ctx->parent)
		if (ctx->id.device == id->device
		    && ctx->id.i_node == id->i_node)
			break;
	return ctx;
}
	
/* Push input context */	
static void
inctx_push()
{
	struct inctx *ctx = xmalloc(sizeof(*ctx));

	ctx->locus = locus;
	ctx->id = input_file_id;
	ctx->file = yyin;
	ctx->pp_pid = pp_pid;
	ctx->inctx_flags = inctx_flags;
	ctx->buf = YY_CURRENT_BUFFER;
	ctx->parent = inctx_tos;
	inctx_tos = ctx;
}

/* Pop input context from the top of the stack into the current
   input context. Return 1 if there are no more contexts left. */
int
inctx_pop()
{
	struct inctx *ctx = inctx_tos;
	
	if (!ctx)
		return 1;

	inctx_tos = ctx->parent;
	
	locus = ctx->locus;
	yyin = ctx->file; 
	input_file_id = ctx->id;
	inctx_flags = ctx->inctx_flags;
	yy_delete_buffer(YY_CURRENT_BUFFER);
	yy_switch_to_buffer(ctx->buf);
	pp_pid = ctx->pp_pid;
	free(ctx);
	return 0;
}

/* Setup the scanner for input from the file NAME. Return 0 on success,
   and an appropriate EX_ code on error. See lex_new_source below. */
static int
lex_new_source_0(const char *name)
{
	if (ext_pp) {
		char *ppcmd;
		
		yyin = pp_extrn_start(name, &pp_pid);
		if (!yyin) {
			parse_error(_("unable to start external preprocessor `%s': %s"),
				    ppcmd,
				    mu_strerror(errno));
			return EX_OSFILE;
		}
	} else {
		yyin = fopen(name, "r");
		if (!yyin) {
			parse_error(_("cannot open %s: %s"), name,
				    mu_strerror(errno));
			return EX_NOINPUT;
		}
	}
	yy_switch_to_buffer(yy_create_buffer(yyin,YY_BUF_SIZE));
	assign_locus(&locus, name, "1");
	return EX_OK;
}

/* Save the current input context on stack and set up the scanner for
   input from the file NAME. Return 0 on success,
   and an appropriate EX_ code on error. */
int
lex_new_source(const char *name, int flag)
{
	int rc;
	struct stat st;
	struct input_file_ident id;
	struct inctx *pctx;
	
	if (stat(name, &st)) {
		parse_error(_("cannot open `%s': %s"),
			    name, mu_strerror(errno));
		return EX_NOINPUT;
	}
	
	id.device = st.st_dev;
	id.i_node = st.st_ino;
	
	pctx = inctx_locate(&id);
	if (pctx) {
		parse_error(_("recursive inclusion"));
		if (pctx->parent)
			parse_error_locus(&pctx->parent->locus,
					  _("`%s' already included here"),
					  name);
		else
			parse_error(_("`%s' already included at top level"),
				    name);
		return 1;
	}
	
	if (flag == LEX_ONCE && source_lookup(&id))
		return 0;

	if (yyin)
		inctx_push();
	rc = lex_new_source_0(name);
	if (rc)
		inctx_pop();
	else {
		input_file_id = id;
		if (flag == LEX_MODULE) {
			inctx_flags = INCTX_MODULE;
			emit_token = T_MODBEG;
		} else
			inctx_flags = 0;
	}
	return rc;
}


/* Return constant or variable token corresponding to the current
   value of yylval.literal->text. */
static int
variable_or_const()
{
	struct variable *vptr;
	const struct constant *cptr;

	cptr = constant_lookup(yylval.literal->text);
	if (cptr) {
		const struct value *value_ptr = &cptr->value;
		switch (value_ptr->type) {
		case dtype_number:
			yylval.number = value_ptr->v.number;
			return T_NUMBER;

		case dtype_string:
			yylval.literal = value_ptr->v.literal;
			return T_STRING;
			
		default:
			abort();
		}
	}

	vptr = variable_lookup(yylval.literal->text);
	if (!vptr) {
		parse_error(_("variable %s is not defined"),
			    yylval.literal->text);
		return T_BOGUS;
	}
	add_xref(vptr, &locus);
	yylval.var = vptr;
	return T_VARIABLE;
}
	
/* Advance locus to the next line */
void
advance_line()
{
	++locus.line;
	locus.point = 0;
	locus.leng = 0;
}

/* Same as BEGIN, but also saves the current locus. It is then used
   to report unclosed constructs at the end of file. */
#define BEGIN_X(s) do { BEGIN(s); start_locus = locus; } while(0)

/* If emit_token is not 0, push back current input and return the value
   of emit_token. Clear emit_token before returning. */
#define YY_USER_ACTION							\
	if (emit_token) {						\
		int tok = emit_token;					\
		emit_token = 0;						\
		if (yy_flex_debug)					\
			fprintf(stderr, "--emitting %d (module %s)\n",	\
				tok,top_module->name);			\
		yyless(0);						\
		yylloc.beg = yylloc.end = locus;			\
		yylloc.beg.point -= yyleng;				\
		return tok;						\
 	} else {							\
 		locus.point += yyleng;					\
 		locus.leng = yyleng;					\
		yylloc.beg = yylloc.end = locus;			\
		yylloc.beg.point -= yyleng;				\
  	}

/* Read next input chunk. */
#define YY_INPUT(buf,result,max_size)					\
	if (yyin == NULL)						\
		result = YY_NULL;					\
	else if (((result = fread(buf, 1, max_size, yyin)) == 0)	\
		 && ferror(yyin))					\
		YY_FATAL_ERROR("input in flex scanner failed");

/* Redeclare main entry point. Actual yylex is defined in the code section
   below. */
#define YY_DECL static int lexscan(void)


/* String composer */
static struct locus string_beg;
static NODE *string_head, *string_tail;

static void
compose_add_node(NODE *node)
{
	if (string_tail)
		string_tail->next = node;
	else
		string_head = node;
	string_tail = node;
}

static void
compose_start(int state)
{
	if (string_head) {
		parse_error("INTERNAL ERROR: previous composition has not "
			    "finished when a new one started");
		abort();
	}
	string_beg = locus;
	string_beg.point -= string_beg.leng;
	BEGIN_X(state);
}

static int
compose_finish()
{
	if (string_tail != string_head) {
		while (string_head->next) {
			NODE *cat = alloc_node(node_type_strcat,
					       &string_head->locus);
			NODE *next = string_head->next;
			cat->next = next->next;
			cat->v.concat.arg[0] = cast_to(dtype_string,
						       string_head);
			cat->v.concat.arg[1] = cast_to(dtype_string, next);
			string_head->next = next->next = NULL;
			string_head = cat;
		}
	}
	yylval.node = string_head;
	yylloc.beg = string_beg;
	string_head = string_tail = NULL;
	return T_COMPOSE;
}

static void
compose_add_literal(struct literal *lit)
{
	NODE *node = alloc_node(node_type_string, &locus);
	node->v.literal = lit;
	compose_add_node(node);
	if (yy_flex_debug)
		fprintf(stderr, "--add literal: '%s'\n", lit->text);
}

static void
compose_add_string(const char *text, size_t length)
{
	compose_add_literal(string_alloc(text, length));
}

static void
compose_add_number(long num)
{
	NODE *node = alloc_node(node_type_number, &locus);
	node->v.number = num;
	compose_add_node(node);
}

void
compose_add_builtin_const(const char *s, size_t len)
{
	const char *sval;
	long nval;
	
	switch (builtin_const_value(s, len, &sval, &nval)) {
	case dtype_number:
		compose_add_number(nval);
		break;

	case dtype_string:
		compose_add_string(sval, strlen(sval));
		break;

	default:
		abort();
	}
}

void
compose_add_variable_or_const(int what)
{
	switch (what) {
	case T_NUMBER:
		compose_add_number(yylval.number);
		break;

	case T_STRING:
		compose_add_literal(yylval.literal);
		break;

	case T_VARIABLE:
		compose_add_node(create_node_variable(yylval.var, &locus));
	}
}

/* Exclusive states:

   COMMENT        Within a C-style comment;
   STR            Processing a complex string;
   ML             Within a multi-line aggregator.  The line being built
                  requires stripping leading whitespace (if requested).
   CML            Continuation within a multi-line aggregator.  The line
                  being built does not require stripping leading whitespace.
   QML            Quoted multi-line aggregator.  No variable substitution and
                  unquoting is needed.

   Inclusive states:
   
   ONBLOCK	  Lexical tie-in after an `on' keyword.  In ONBLOCK state
                  the strigns `as', `host', `from', and `poll' are
		  recognized as keywords.  The string `for' also acquires
		  special meaning.
*/


#line 1824 "lex.c"

#define INITIAL 0
#define COMMENT 1
#define STR 2
#define ML 3
#define CML 4
#define QML 5
#define ONBLOCK 6

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
/* %if-c-only */
#include <unistd.h>
/* %endif */
/* %if-c++-only */
/* %endif */
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* %if-c-only Reentrant structure and macros (non-C++). */
/* %if-reentrant */
/* %if-c-only */

static int yy_init_globals (void );

/* %endif */
/* %if-reentrant */
/* %endif */
/* %endif End reentrant structures and macros. */

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* %if-bison-bridge */
/* %endif */

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

/* %not-for-header */

    static void yyunput (int c,char *buf_ptr  );
    
/* %ok-for-header */

/* %endif */

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT
/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif
/* %ok-for-header */

/* %endif */
#endif

/* %if-c-only */

/* %endif */

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* %if-c-only Standard (non-C++) definition */
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO fwrite( yytext, yyleng, 1, yyout )
/* %endif */
/* %if-c++-only C++ definition */
/* %endif */
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
/* %% [5.0] fread()/read() definition of YY_INPUT goes here unless we're doing C++ \ */\
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\
/* %if-c++-only C++ definition \ */\
/* %endif */

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
/* %if-c-only */
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
/* %endif */
/* %if-c++-only */
/* %endif */
#endif

/* %if-tables-serialization structures and prototypes */
/* %not-for-header */

/* %ok-for-header */

/* %not-for-header */

/* %tables-yydmap generated elements */
/* %endif */
/* end tables serialization structures and prototypes */

/* %ok-for-header */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1
/* %if-c-only Standard (non-C++) definition */

extern int yylex (void);

#define YY_DECL int yylex (void)
/* %endif */
/* %if-c++-only C++ definition */
/* %endif */
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

/* %% [6.0] YY_RULE_SETUP definition goes here */
#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/* %not-for-header */

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
/* %% [7.0] user's declarations go here */
#line 464 "lex.l"

         /* C-style comments */
#line 2078 "lex.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
/* %if-c-only */
			yyin = stdin;
/* %endif */
/* %if-c++-only */
/* %endif */

		if ( ! yyout )
/* %if-c-only */
			yyout = stdout;
/* %endif */
/* %if-c++-only */
/* %endif */

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
/* %% [8.0] yymore()-related code goes here */
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

/* %% [9.0] code to set up and find next match goes here */
		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 960 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2184 );

yy_find_action:
/* %% [10.0] code to find the action number goes here */
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

/* %% [11.0] code for yylineno update goes here */

do_action:	/* This label is used only to access EOF actions. */

/* %% [12.0] debug code goes here */
		if ( yy_flex_debug )
			{
			if ( yy_act == 0 )
				fprintf( stderr, "--scanner backing up\n" );
			else if ( yy_act < 143 )
				fprintf( stderr, "--accepting rule at line %ld (\"%s\")\n",
				         (long)yy_rule_linenum[yy_act], yytext );
			else if ( yy_act == 143 )
				fprintf( stderr, "--accepting default rule (\"%s\")\n",
				         yytext );
			else if ( yy_act == 144 )
				fprintf( stderr, "--(end of buffer or a NUL)\n" );
			else
				fprintf( stderr, "--EOF (start condition %d)\n", YY_START );
			}

		switch ( yy_act )
	{ /* beginning of action switch */
/* %% [13.0] actions go here */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 466 "lex.l"
BEGIN_X(COMMENT);
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 467 "lex.l"
/* eat anything that's not a '*' */
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 468 "lex.l"
/* eat up '*'s not followed by '/'s */
	YY_BREAK
case 4:
/* rule 4 can match eol */
YY_RULE_SETUP
#line 469 "lex.l"
advance_line();
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 470 "lex.l"
BEGIN(INITIAL);
	YY_BREAK
/* Configuration directives */
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 472 "lex.l"
parse_line_cpp(yytext, &locus);
	YY_BREAK
/* Normally, everything within a comment should be ignored, so
	   the exclusive condition for the rule below is an error.
	   Unfortunately, GNU m4 (versions up to 1.4.9) outputs line
	   synchronisation directives in comments, which makes any decent
	   compiler lost trace of which input line it is on.  To avoid
	   this, mfd handles #line directives even within a C-comment
	   block.

	   The bug report with a patch was sent to bug-m4@gnu.org on
	   2007-05-24:

	     http://lists.gnu.org/archive/html/bug-m4/2007-05/msg00018.html
	     
	   Hopefully it will be fixed in the next release.
	*/
case 7:
/* rule 7 can match eol */
YY_RULE_SETUP
#line 488 "lex.l"
{
	parse_line(yytext, &locus);
}
	YY_BREAK
case 8:
/* rule 8 can match eol */
YY_RULE_SETUP
#line 491 "lex.l"
{
	yyless(yyleng-1);
	parse_pragma(yytext);
 }
	YY_BREAK
case 9:
/* rule 9 can match eol */
YY_RULE_SETUP
#line 495 "lex.l"
{
         yytext[yyleng-1] = 0; /* Kill trailing newline */
         parse_error("%s", yytext);
         advance_line();
 }
	YY_BREAK
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
#line 500 "lex.l"
{
	parse_include(yytext, 1);
}
	YY_BREAK
case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 503 "lex.l"
{
	parse_include(yytext, 0);
}
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 506 "lex.l"
{
	/* parse_require cannot be called directly from lexer to avoid
	   switching module context in the middle of grammar rule. */
	yylval.string = yytext;
	return T_SHARPREQR;
}
	YY_BREAK
/* End-of-line comments */
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 513 "lex.l"
{ advance_line(); }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 514 "lex.l"
/* end-of-file comment */;
	YY_BREAK
/* Reserved words */
case 15:
YY_RULE_SETUP
#line 516 "lex.l"
return T_ACCEPT;
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 517 "lex.l"
return T_REJECT;
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 518 "lex.l"
return T_TEMPFAIL;
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 519 "lex.l"
return T_CONTINUE;
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 520 "lex.l"
return T_DISCARD;
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 521 "lex.l"
return T_ADD;
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 522 "lex.l"
return T_REPLACE;
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 523 "lex.l"
return T_DELETE;
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 524 "lex.l"
return T_IF;
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 525 "lex.l"
return T_FI;
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 526 "lex.l"
return T_ELSE;
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 527 "lex.l"
return T_ELIF;
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 528 "lex.l"
return T_ON;
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 529 "lex.l"
return T_DO;
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 530 "lex.l"
return T_DONE;
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 531 "lex.l"
return T_MATCHES;
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 532 "lex.l"
return T_FNMATCHES;
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 533 "lex.l"
return T_MXMATCHES;
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 534 "lex.l"
return T_MXFNMATCHES;
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 535 "lex.l"
return T_WHEN;
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 536 "lex.l"
return T_OR;
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 537 "lex.l"
return T_AND;
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 538 "lex.l"
return T_NOT;
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 539 "lex.l"
return T_NEXT;
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 540 "lex.l"
return T_PROG;
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 541 "lex.l"
return T_SET;
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 542 "lex.l"
return T_CATCH;
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 543 "lex.l"
return T_ECHO;
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 544 "lex.l"
return T_RETURN;
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 545 "lex.l"
return T_RETURNS;
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 546 "lex.l"
return T_FUNC;
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 547 "lex.l"
return T_SWITCH;
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 548 "lex.l"
return T_CASE;
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 549 "lex.l"
return T_DEFAULT;
	YY_BREAK
case 49:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 6;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 550 "lex.l"
{ yylval.type = dtype_string; return T_TYPECAST; }
	YY_BREAK
case 50:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 6;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 551 "lex.l"
{ yylval.type = dtype_number; return T_TYPECAST; }
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 552 "lex.l"
{ yylval.type = dtype_string; return T_TYPE; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 553 "lex.l"
{ yylval.type = dtype_number; return T_TYPE; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 554 "lex.l"
return T_CONST;
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 555 "lex.l"
return T_THROW;
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 556 "lex.l"
return T_LOOP;
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 557 "lex.l"
return T_WHILE;
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 558 "lex.l"
return T_FOR;
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 559 "lex.l"
return T_BREAK;
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 560 "lex.l"
return T_PASS;
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 561 "lex.l"
return T_BEGIN;
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 562 "lex.l"
return T_END;
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 563 "lex.l"
return T_ALIAS;
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 564 "lex.l"
return T_VAPTR;
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 565 "lex.l"
return T_PRECIOUS;
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 566 "lex.l"
return T_REQUIRE;
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 567 "lex.l"
return T_IMPORT;
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 568 "lex.l"
return T_FROM;
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 569 "lex.l"
return T_STATIC;
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 570 "lex.l"
return T_PUBLIC;
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 571 "lex.l"
{  if (inctx_tos && inctx_flags == 0) {
                int c;
		char *fname = base_name(locus.file);
		size_t flen = strlen(fname);
		
		if (flen > 3
		    && strcmp(fname + flen - 3, ".mf") == 0)
		  fname[flen - 3] = 0; 
		parse_warning_locus(&inctx_tos->locus,
				    _("including a module file is unreliable and may cause subtle errors"));
		/* TRANSLATORS: Do not translate `require %s' */
		parse_warning_locus(&inctx_tos->locus,
				    _("use `require %s' instead"),
				    fname);
		free (fname);
		inctx_flags |= INCTX_IGNORE_BYE;
		start_locus = locus;
		while ((c = input()) != '.') {
		    if (c == 0) {
		        parse_error_locus(&start_locus,
					  _("unexpected end of file"));
		     	return 0;
		    } else if (c == '\n')
		        advance_line();
		}
	     } else {
	          if (inctx_flags & INCTX_HADINPUT) 
		     parse_error(_("misplaced `module'"));
 	          return T_MODULE;
	     }
          }
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 602 "lex.l"
{
             if (inctx_flags & INCTX_IGNORE_BYE) {
	          /* It is an included module. Return EOF immediately.
                     A warning message has already been issued. */
		  return 0;
	     } else
                  return T_BYE;
           }
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 610 "lex.l"
{ return builtin_const(yytext, yyleng); } 
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 611 "lex.l"
return T_POLL;
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 612 "lex.l"
return T_HOST;
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 613 "lex.l"
return T_AS;
	YY_BREAK
/* Variables */
case 76:
YY_RULE_SETUP
#line 615 "lex.l"
{
	return builtin_const(yytext + 1, yyleng - 1);
}
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 618 "lex.l"
{
	compose_add_builtin_const(yytext + 1, yyleng - 1);
}	
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 621 "lex.l"
{
	return builtin_const(yytext + 2, yyleng - 3);
}
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 624 "lex.l"
{
	compose_add_builtin_const(yytext + 2, yyleng - 3);
}
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 627 "lex.l"
{
	string(yytext + 1, yyleng - 1);
	return variable_or_const();
}
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 631 "lex.l"
{
	string(yytext + 1, yyleng - 1);
	compose_add_variable_or_const(variable_or_const());
}
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 635 "lex.l"
{
	string(yytext + 2, yyleng - 3);
	return variable_or_const();
}
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 639 "lex.l"
{
	string(yytext + 2, yyleng - 3);
	compose_add_variable_or_const(variable_or_const());
}
	YY_BREAK
/* Positional arguments */
case 84:
YY_RULE_SETUP
#line 644 "lex.l"
{
	return T_ARGCOUNT;
}
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 647 "lex.l"
{
	compose_add_node(create_node_argcount(&locus));
}
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 650 "lex.l"
{
	yylval.number = strtol(yytext + 1, NULL, 0);
	return T_ARG; }
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 653 "lex.l"
{
	compose_add_node(create_node_arg(strtol(yytext + 1, NULL, 0), &locus));
 }
	YY_BREAK
case 88:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 656 "lex.l"
{ return T_ARGX; }
	YY_BREAK
/* Sendmail variables */
case 89:
YY_RULE_SETUP
#line 658 "lex.l"
{
	        if (yyleng == 2)
	           string(yytext + 1, 1);
                else {
                   line_begin();
                   line_add("{", 1);
                   line_add(yytext + 1, yyleng - 1);
                   line_add("}", 1);
                   line_finish();
                }
                return T_SYMBOL;
              }
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 670 "lex.l"
{
	        if (yyleng == 2)
	           string(yytext + 1, 1);
                else {
                   line_begin();
                   line_add("{", 1);
                   line_add(yytext + 1, yyleng - 1);
                   line_add("}", 1);
                   line_finish();
                }
		compose_add_node(create_node_symbol(yylval.literal, &locus));
              }
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 682 "lex.l"
{
	string(yytext+1, yyleng - 1); return T_SYMBOL; }
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 684 "lex.l"
{
	string(yytext+1, yyleng - 1);
	compose_add_node(create_node_symbol(yylval.literal, &locus)); }
	YY_BREAK
/* Back-references */
case 93:
YY_RULE_SETUP
#line 688 "lex.l"
{
	 yylval.number = strtoul(yytext+1, NULL, 0);
	 return T_BACKREF; }
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 691 "lex.l"
{
	compose_add_node(create_node_backref(strtoul(yytext+1, NULL, 10),
					     &locus)); }
	YY_BREAK
/* Numeric strings */
case 95:
YY_RULE_SETUP
#line 695 "lex.l"
{ yylval.number = strtoul(yytext, NULL, 16); return T_NUMBER; };
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 696 "lex.l"
{ yylval.number = strtoul(yytext, NULL, 8); return T_NUMBER; };
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 697 "lex.l"
{ yylval.number = strtoul(yytext, NULL, 10); return T_NUMBER; };
	YY_BREAK
/* Identifiers */
case 98:
YY_RULE_SETUP
#line 699 "lex.l"
{
	enum { is_ident, is_builtin, is_func } state;

	if (yylval.builtin = builtin_lookup(yytext))
		state = is_builtin;
	else if (yylval.function = function_lookup(yytext))
		state = is_func;
	else
		state = is_ident;

	if (state != is_ident) {
		int c;
		
		while ((locus.point++, c = input())
		       && c_isascii(c) && c_isspace(c))
			if (c == '\n')
				advance_line();
		
		paren_follows = (c == '(');
		unput(c);
		locus.point--;
	}
	
	if (state == is_builtin) 
		return yylval.builtin->rettype == dtype_unspecified ?
			T_BUILTIN_PROC :
			(paren_follows ? T_BUILTIN : T_BUILTIN_P);
	else if (state == is_func)
		return yylval.function->rettype == dtype_unspecified ?
			T_FUNCTION_PROC :
			(paren_follows ? T_FUNCTION : T_FUNCTION_P);
	else {
		string(yytext, yyleng);
		return T_IDENTIFIER;
	}
  }
	YY_BREAK
/* Strings */
case 99:
YY_RULE_SETUP
#line 736 "lex.l"
{ string(yytext+1, yyleng-2); return T_STRING; }
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 737 "lex.l"
{ string(yytext+1, yyleng-2); return T_STRING; }
	YY_BREAK
case 101:
/* rule 101 can match eol */
YY_RULE_SETUP
#line 738 "lex.l"
{ advance_line();
                        compose_start(STR);
                        compose_add_string(yytext + 1, yyleng - 3); }
	YY_BREAK
case 102:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 741 "lex.l"
{ compose_start(STR);
                        compose_add_string(yytext+1, yyleng-1); }
	YY_BREAK
case 103:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 5;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 743 "lex.l"
{
         compose_start(STR);
         line_add_char(strtoul(yytext + 3, NULL, 16));
         compose_add_literal(string_finish());
}
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 748 "lex.l"
{
         compose_start(STR);
         line_add_char(strtoul(yytext + 3, NULL, 16));
}
	YY_BREAK
case 105:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 753 "lex.l"
{
         compose_start(STR);
         line_add_char(strtoul(yytext + 3, NULL, 8));
         compose_add_literal(string_finish());
}
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 758 "lex.l"
{
         compose_start(STR);  
         line_add_char(strtoul(yytext + 3, NULL, 8));
}
	YY_BREAK
case 107:
/* rule 107 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 3;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 763 "lex.l"
{
         compose_start(STR);
         line_add_char(mu_argcv_unquote_char(yytext[2]));
         compose_add_literal(string_finish());
}
	YY_BREAK
case 108:
/* rule 108 can match eol */
YY_RULE_SETUP
#line 768 "lex.l"
{
         compose_start(STR);
         line_add_char(mu_argcv_unquote_char(yytext[2]));
}
	YY_BREAK
case 109:
/* rule 109 can match eol */
YY_RULE_SETUP
#line 772 "lex.l"
{ advance_line(); line_add(yytext, yyleng - 2); }
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 773 "lex.l"
{ BEGIN(INITIAL);
                        if (yyleng > 1)
                          line_add(yytext, yyleng - 1);
                        compose_add_literal(string_finish());
                        return compose_finish(); }
	YY_BREAK
case 111:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 778 "lex.l"
{
                       line_add(yytext, yyleng);
                       compose_add_literal(string_finish());
                       line_begin();
                 }
	YY_BREAK
case 112:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 4;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 783 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 16));
         compose_add_literal(string_finish());       
         line_begin();
}
	YY_BREAK
case 113:
YY_RULE_SETUP
#line 788 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 16));
}
	YY_BREAK
case 114:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 791 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 8));
         compose_add_literal(string_finish());
         line_begin();
}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 796 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 8));
}
	YY_BREAK
case 116:
/* rule 116 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 2;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 799 "lex.l"
{
         line_add_char(mu_argcv_unquote_char(yytext[1]));
         compose_add_literal(string_finish());
         line_begin();
}
	YY_BREAK
case 117:
/* rule 117 can match eol */
YY_RULE_SETUP
#line 804 "lex.l"
{
         line_add_char(mu_argcv_unquote_char(yytext[1]));
}
	YY_BREAK
/* Multi-line strings */
case 118:
/* rule 118 can match eol */
#line 810 "lex.l"
case 119:
/* rule 119 can match eol */
YY_RULE_SETUP
#line 810 "lex.l"
{
        char *p;

        advance_line();
        char_to_strip = NULL;
        multiline_unescape = 1;

        line_begin();
        p = yytext + 2;
        if (*p == '-') {
            ++p;
            if (*p == ' ') {
                ++p;
                char_to_strip = is_space;
            } else
                char_to_strip = is_tab;
        }
        
        if (*p == '\\') {
            p++;
            multiline_unescape = 0;
        }
        if (*p == '\'') {
            char *q;
 
            p++;
            multiline_unescape = 0;
            q = strchr(p, '\'');
            multiline_delimiter_len = q - p;
        } else
            multiline_delimiter_len = strcspn(p, " \t");

        multiline_delimiter = xmalloc(multiline_delimiter_len + 1);
        memcpy(multiline_delimiter, p, multiline_delimiter_len);
        multiline_delimiter[multiline_delimiter_len] = 0;
        if (multiline_unescape)
            compose_start(ML);
        else
            compose_start(QML);
}
	YY_BREAK
/* Quoted multilines */
case 120:
/* rule 120 can match eol */
YY_RULE_SETUP
#line 851 "lex.l"
{
        char *p;

        advance_line();
        p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;

        if (strlen(p) >= multiline_delimiter_len
            && memcmp(p, multiline_delimiter, multiline_delimiter_len) == 0
            && isemptystr(p + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(p, strlen(p));
}
	YY_BREAK
/* Unquoted multilines */
case 121:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 874 "lex.l"
{
        char *p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;
        line_add(p, strlen(p));
        compose_add_literal(string_finish());
        BEGIN_X(CML);
}
	YY_BREAK
case 122:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 883 "lex.l"
{
        line_add(yytext, yyleng);
        compose_add_literal(string_finish());
        line_begin();
}
	YY_BREAK
case 123:
YY_RULE_SETUP
#line 888 "lex.l"
{
        line_add(yytext, 1);
        compose_add_literal(string_finish());
        line_begin();
}
	YY_BREAK
case 124:
YY_RULE_SETUP
#line 893 "lex.l"
{
        line_add(yytext, yyleng);
}
	YY_BREAK
case 125:
/* rule 125 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 896 "lex.l"
{
        char *p;

        advance_line();
        p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;

        if (strlen(p) >= multiline_delimiter_len
            && memcmp(p, multiline_delimiter, multiline_delimiter_len) == 0
            && isemptystr(p + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(p, strlen(p));
        compose_add_literal(string_finish());
}
	YY_BREAK
case 126:
/* rule 126 can match eol */
YY_RULE_SETUP
#line 918 "lex.l"
{
        char *p;

        advance_line();
        p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;

        if (strlen(p) >= multiline_delimiter_len
            && memcmp(p, multiline_delimiter, multiline_delimiter_len) == 0
            && isemptystr(p + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(p, strlen(p));
}
	YY_BREAK
case 127:
/* rule 127 can match eol */
YY_RULE_SETUP
#line 939 "lex.l"
{
        advance_line();
        if (yyleng >= multiline_delimiter_len
            && memcmp(yytext, multiline_delimiter,
                      multiline_delimiter_len) == 0
            && isemptystr(yytext + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(yytext, yyleng);
        BEGIN_X(ML);
}
	YY_BREAK
/* Other tokens */
case 128:
YY_RULE_SETUP
#line 956 "lex.l"
;
	YY_BREAK
case 129:
/* rule 129 can match eol */
YY_RULE_SETUP
#line 957 "lex.l"
{ advance_line(); }
	YY_BREAK
case 130:
YY_RULE_SETUP
#line 958 "lex.l"
return T_EQ;
	YY_BREAK
case 131:
YY_RULE_SETUP
#line 959 "lex.l"
return T_NE;
	YY_BREAK
case 132:
YY_RULE_SETUP
#line 960 "lex.l"
return T_LT;
	YY_BREAK
case 133:
YY_RULE_SETUP
#line 961 "lex.l"
return T_LE;
	YY_BREAK
case 134:
YY_RULE_SETUP
#line 962 "lex.l"
return T_GT;
	YY_BREAK
case 135:
YY_RULE_SETUP
#line 963 "lex.l"
return T_GE;
	YY_BREAK
case 136:
YY_RULE_SETUP
#line 964 "lex.l"
return T_LOGAND;
	YY_BREAK
case 137:
YY_RULE_SETUP
#line 965 "lex.l"
return T_LOGOR;
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 966 "lex.l"
return T_LOGXOR;
	YY_BREAK
case 139:
YY_RULE_SETUP
#line 967 "lex.l"
return T_LOGNOT;
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 968 "lex.l"
return T_DOTS;
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 969 "lex.l"
/* If a here-document is not closed and its next line does not
               end with a \n, prevent it from being displayed by ECHO */;
	YY_BREAK
case 142:
YY_RULE_SETUP
#line 971 "lex.l"
return yytext[0];
	YY_BREAK
case 143:
YY_RULE_SETUP
#line 972 "lex.l"
ECHO;
	YY_BREAK
#line 3329 "lex.c"
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(STR):
case YY_STATE_EOF(ML):
case YY_STATE_EOF(CML):
case YY_STATE_EOF(QML):
case YY_STATE_EOF(ONBLOCK):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
/* %% [14.0] code to do back-up for compressed tables and set up yy_cp goes here */
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */
/* %ok-for-header */

/* %if-c++-only */
/* %not-for-header */

/* %ok-for-header */

/* %endif */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
/* %if-c-only */
static int yy_get_next_buffer (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

/* %if-c-only */
/* %not-for-header */

    static yy_state_type yy_get_previous_state (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
/* %% [15.0] code to get the start state into yy_current_state goes here */
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
/* %% [16.0] code to find the next state goes here */
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 960 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
/* %if-c-only */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
/* %endif */
/* %if-c++-only */
/* %endif */
{
	register int yy_is_jam;
    /* %% [17.0] code to find the next state, and perhaps do backing up, goes here */
	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 960 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 959);

	return yy_is_jam ? 0 : yy_current_state;
}

/* %if-c-only */

    static void yyunput (int c, register char * yy_bp )
/* %endif */
/* %if-c++-only */
/* %endif */
{
	register char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up yytext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = (yy_n_chars) + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

/* %% [18.0] update yylineno here */

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}
/* %if-c-only */

/* %endif */

/* %if-c-only */
#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

/* %endif */
/* %if-c++-only */
/* %endif */
{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

/* %% [19.0] update BOL and yylineno */
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');

	return c;
}
/* %if-c-only */
#endif	/* ifndef YY_NO_INPUT */
/* %endif */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
/* %if-c-only */
    void yyrestart  (FILE * input_file )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
/* %if-c-only */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

/* %if-c-only */
static void yy_load_buffer_state  (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
/* %if-c-only */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
/* %endif */
/* %if-c++-only */
/* %endif */
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
/* %if-c-only */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

/* %if-c-only */

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* %endif */

/* %if-c++-only */
/* %endif */

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
/* %if-c-only */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )
/* %endif */
/* %if-c++-only */
/* %endif */

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

/* %if-c-only */

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
/* %endif */
/* %if-c++-only */
/* %endif */
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
/* %if-c-only */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/* %if-c-or-c++ */
/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
/* %if-c-only */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}
/* %endif */

/* %if-c-or-c++ */
/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
/* %if-c-only */
void yypop_buffer_state (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}
/* %endif */

/* %if-c-or-c++ */
/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
/* %if-c-only */
static void yyensure_buffer_stack (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}
/* %endif */

/* %if-c-only */
/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}
/* %endif */

/* %if-c-only */
/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}
/* %endif */

/* %if-c-only */
/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}
/* %endif */

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

/* %if-c-only */
static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}
/* %endif */
/* %if-c++-only */
/* %endif */

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/* %if-c-only */
/* %if-reentrant */
/* %endif */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/* %if-reentrant */
/* %endif */

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

/* %endif */

/* %if-reentrant */
/* %if-bison-bridge */
/* %endif */
/* %endif if-c-only */

/* %if-c-only */
static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}
/* %endif */

/* %if-c-only SNIP! this currently causes conflicts with the c++ scanner */
/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

/* %if-reentrant */
/* %endif */
    return 0;
}
/* %endif */

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

/* %if-tables-serialization definitions */
/* %define-yytables   The name for this specific scanner's tables. */
#define YYTABLES_NAME "yytables"
/* %endif */

/* %ok-for-header */

#line 972 "lex.l"



int
yylex()
{
        int rc = lexscan();
	if (rc != T_MODBEG && rc != T_MODEND)
		inctx_flags |= INCTX_HADINPUT;
	return rc;
}

void
init_string_space()
{
	obstack_init(&string_stk);
}

void
free_string_space()
{
	obstack_free(&string_stk, NULL);
}

char *
mf_strdup(const char *str)
{
	string_add(str, strlen(str) + 1);
	return obstack_finish(&string_stk);
}

struct literal *
string_alloc(const char *str, size_t len)
{
	string_begin();
	string_add(str, len);
	return string_finish();
}

static void
string(const char *str, size_t len)
{
	yylval.literal = string_alloc(str, len);
}

void
string_begin()
{
	/* nothing */
}

struct literal *
string_finish()
{
	char *ptr;
	struct literal *lit;
	obstack_1grow(&string_stk, 0);
	ptr = obstack_finish(&string_stk);
	lit = literal_lookup(ptr);
	if (lit->text != ptr)
		obstack_free(&string_stk, ptr);
	return lit;
}

static void
line_finish()
{	
	yylval.literal = string_finish();
	if (yy_flex_debug)
		fprintf(stderr, "constructed line: %s\n",
			yylval.literal->text);
}		

void
string_add(const char *str, size_t len)
{
	obstack_grow(&string_stk, str, len);
}

void
string_add_char(unsigned char c)
{
	obstack_1grow(&string_stk, c);
}

void
print_parse_message(const struct locus *locus,
		    const char *prefix, const char *fmt, va_list ap)
{
	int n;
	char buf[512]; /* FIXME */

	if (locus && locus->file) {
		if (location_column_option)
			n = snprintf(buf, sizeof buf, "%s:%lu:%lu: ",
				     locus->file, (unsigned long) locus->line,
				     (unsigned long)locus->point);
		else
			n = snprintf(buf, sizeof buf, "%s:%lu: ",
				     locus->file, (unsigned long) locus->line);
	} else
		n = 0;
	if (prefix) 
		n += snprintf(buf + n, sizeof buf - n, "%s: ", prefix);
	vsnprintf(buf + n, sizeof buf - n, gettext(fmt), ap);
	mu_error("%s", buf);
}

void
parse_warning(const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	print_parse_message(&locus, _("warning"), fmt, ap);
	va_end(ap);
}

void
parse_warning_locus(const struct locus *loc, const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	print_parse_message(loc, _("warning"), fmt, ap);
	va_end(ap);
}

void
parse_error(const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	print_parse_message(&locus, NULL, fmt, ap);
	va_end(ap);
	error_count++;
}

void
parse_error_locus(const struct locus *loc, const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	print_parse_message(loc, NULL, fmt, ap);
	va_end(ap);
	error_count++;
}



static int
lex_close_source()
{
	if (!yyin)
		return 1;
	if (ext_pp)
 	        pp_extrn_shutdown(yyin, pp_pid);
	else
		fclose(yyin);
	yyin = NULL;
	
	switch (YYSTATE) {
	case INITIAL:
		/* ok */
		break;

	case COMMENT:
		parse_error_locus(&start_locus, _("end of file in comment"));
		break;

	case STR:
	case ML:
	case CML:
	case QML:
		parse_error_locus(&start_locus, _("end of file in string"));
	}
	return inctx_pop();
}

void
lex_drain_input()
{
	while (input() != EOF)
		;
}

void
lex_bye()
{
	lex_drain_input();
	lex_close_source();
}

int
yywrap()
{
	if (yy_flex_debug && top_module)
		fprintf(stderr, "--eof in module %s\n", top_module->name);
	if (inctx_flags & INCTX_MODULE)
		emit_token = T_MODEND;
	return lex_close_source();
}

static int
isemptystr(char *text)
{
	for (; *text && c_isspace (*text); text++)
		;
	return *text == 0;
}

void
tie_in_onblock(int enable)
{
	if (enable)
		BEGIN(ONBLOCK);
	else
		BEGIN(INITIAL);
}

data_type_t
builtin_const_value(const char *s, size_t len, const char **sval, long *nval)
{
	if (strncmp(s, "__file__", len) == 0) {
		struct literal *lit = literal_lookup(locus.file);
		*sval = lit->text;
		return dtype_string;
	} else if (strncmp(s, "__line__", len) == 0) {
		*nval = locus.line;
		return dtype_number;
	} else if (strncmp(s, "__function__", len) == 0) {
		*sval = function_name();
		return dtype_string;
	} else if (strncmp(s, "__package__", len) == 0) {
		*sval = PACKAGE_TARNAME;
		return dtype_string;
	} else if (strncmp(s, "__version__", len) == 0) {
		*sval = PACKAGE_VERSION;
		return dtype_string;
	} else if (strncmp(s, "__major__", len) == 0) {
		*nval = MAILFROMD_VERSION_MAJOR;
		return dtype_number;
	} else if (strncmp(s, "__minor__", len) == 0) {
		*nval = MAILFROMD_VERSION_MINOR;
		return dtype_number;
	} else if (strncmp(s, "__patch__", len) == 0) {
		*nval = MAILFROMD_VERSION_PATCH;
		return dtype_number;
	} else if (strncmp(s, "__statedir__", len) == 0) {
                *sval = mailfromd_state_dir;
		return dtype_string;
	} else if (strncmp(s, "__defstatedir__", len) == 0) {
		*sval = DEFAULT_STATE_DIR;
		return dtype_string;
	} else if (strncmp(s, "__preproc__", len) == 0) {
		*sval = ext_pp;
		return dtype_string;
	} else if (strncmp(s, "__defpreproc__", len) == 0) {
		*sval = (DEFAULT_PREPROCESSOR) ? DEFAULT_PREPROCESSOR : "";
		return dtype_string;
	} else if (strncmp(s, "__module__", len) == 0) {
		*sval = top_module->dclname ? top_module->dclname : top_module->name;
		return dtype_string;
	}
        return dtype_unspecified;  
}

int
builtin_const(const char *s, size_t len)
{
	const char *sval;
	long nval;
	
	switch (builtin_const_value(s, len, &sval, &nval)) {
	case dtype_number:
		yylval.number = nval;
		return T_NUMBER;

	case dtype_string:
		string(sval, strlen(sval));
		return T_STRING;

	default:
		abort();
	}
	return T_BOGUS;
}

const char *
symbit_to_qualifier(unsigned f)
{
        switch (f) {
	case SYM_PRECIOUS:
		return "precious";
	case SYM_STATIC:
		return "static";
	case SYM_PUBLIC:
		return "public";
	}
	return NULL;
}

/* End of lex.l */

